Class: Sketchup::Page

Inherits:
Entity
  • Object
show all

Overview

The Page class contains methods to extract information and modify the properties of an individual page.

Note that inside the SketchUp user interface pages are called “Scenes”.

Version:

  • SketchUp 6.0

Instance Method Summary # collapse

Methods inherited from Entity

#add_observer, #attribute_dictionaries, #attribute_dictionary, #delete_attribute, #deleted?, #entityID, #get_attribute, #inspect, #model, #parent, #persistent_id, #remove_observer, #set_attribute, #to_s, #typename, #valid?

Instance Method Details

#axesObject

The axes method returns the drawing axes for the page.

Examples:

page = Sketchup.active_model.pages.add("Example Page")
xaxis = Geom::Vector3d.new(3, 5, 0)
yaxis = xaxis * Z_AXIS
page.axes.set([10,0,0], xaxis, yaxis, Z_AXIS)

Returns:

  • Axes - the axes for the page.

Version:

  • SketchUp 2016

#cameraObject

The camera method retrieves the camera for a particular page.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
camera = page.camera

Returns:

  • camera - a Camera object if successful, nil if the page does not save camera information

Version:

  • SketchUp 6.0

#delay_timeObject

The delay_time method retrieves the amount of time, in seconds, that a page will be displayed before transition to another page during a tour.

The default delay time can be modified in the Model Info > Animation panel of the SketchUp User Interface. If this method returns -1, the default delay time is used.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
time = page.delay_time

Returns:

  • time - the number of seconds of delay

Version:

  • SketchUp 6.0

#delay_time=(seconds) ⇒ Object

The delay_time= method sets the amount of time, in seconds, that a page will be displayed before transitioning to another page during a tour. If you set the delay for a page to be -1, the default delay time will be used.

The default delay time can be modified in the Model Info > Animation panel of the SketchUp User Interface.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
time = page.delay_time = 10

Returns time - the number of seconds of delay.

Parameters:

  • seconds

    The number of seconds to set as the delay time.

Returns:

  • time - the number of seconds of delay

Version:

  • SketchUp 6.0

#descriptionObject

The description method retrieves the description for a page as found in the Scenes manager dialog.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
description = page.description

Returns:

  • description - a textual description for the page.

Version:

  • SketchUp 6.0

#description=(description) ⇒ Object

The description method sets the description for a page as found in the Scenes manager dialog.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
description = page.description = "This is my first page"

Returns description - the new string description for the page.

Parameters:

  • description

    A string description for the page.

Returns:

  • description - the new string description for the page

Version:

  • SketchUp 6.0

#get_drawingelement_visibility(element) ⇒ Boolean

The #get_drawingelement_visibility method is used to get the visibility of a drawing element on a particular page.

Examples:

model = Sketchup.active_model
entities = model.active_entities
point1 = Geom::Point3d.new(10,0,0)
constpoint = entities.add_cpoint(point1)
pages = model.pages
page = pages.add("My Page")
result = page.get_drawingelement_visibility(constpoint)

Parameters:

Returns:

  • (Boolean)
    • true if visible, false if not.

Version:

  • SketchUp 2020.0

#hidden_entitiesObject

The hidden_entities method retrieves all hidden entities within a page.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
entities = page.hidden_entities

Returns:

  • entities - an Entities object containing hidden entities on the page.

Version:

  • SketchUp 6.0

#include_in_animation=(include) ⇒ Sketchup::Page

The #include_in_animation= method controls whether the page should be included when exporting an animation from the model.

Examples:

Turn off animation for all pages.

model = Sketchup.active_model
model.pages.each { |page|
  page.include_in_animation = false
}

Parameters:

  • include (Boolean)

Returns:

Version:

  • SketchUp 2018

#include_in_animation?Boolean

The #include_in_animation? method determines whether the page should be included when exporting an animation from the model.

Examples:

model = Sketchup.active_model
in_animation = model.pages.select { |page| page.include_in_animation? }

Returns:

  • (Boolean)

Version:

  • SketchUp 2018

#labelObject

The label method retrieves the label for a page from the page tab.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
label = page.label

Returns:

  • label - a string label for the page tab

Version:

  • SketchUp 6.0

#layer_foldersArray<Sketchup::LayerFolder>?

The #layer_folders method retrieves the hidden layer folders associated with a page.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add("My Page")
folders = page.layer_folders

Returns:

Version:

  • SketchUp 2021.0

#layersArray<Sketchup::Layer>?

The #layers method retrieves layers that don't use their default visibility on this page.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add("My Page")
layers = page.layers

Test layer visibility

def visible_in_scene?(layer, scene)
  scene.layers.include?(layer) == hidden_by_default?(layer)
end

def hidden_by_default?(layer)
  layer.page_behavior & LAYER_HIDDEN_BY_DEFAULT == LAYER_HIDDEN_BY_DEFAULT
end

Returns:

Version:

  • SketchUp 6.0

#nameObject

The name method retrieves the name for a page from the page tab.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
name = page.name

Returns:

  • label - a string name for the page tab

Version:

  • SketchUp 6.0

#name=(name) ⇒ Object

The name= method sets the name for a page's tab.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
name = page.name = "Page Name"

Returns name - the name that you have set.

Parameters:

  • name

    The name of the page to be set.

Returns:

  • name - the name that you have set

Version:

  • SketchUp 6.0

#rendering_optionsObject

The rendering_options method retrieves a RenderingOptions object for the page.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
renderingoptions = page.rendering_options

Returns:

  • renderingoptions - a RenderingOptions object

Version:

  • SketchUp 6.0

#set_drawingelement_visibility(element, visibility) ⇒ Boolean

The #set_drawingelement_visibility method is used to change the visibility of a drawing element on a particular page. Only drawing elements on the root of the model, as well as nested instances of components, groups, and images are controlled by Page visibility.

Examples:

model = Sketchup.active_model
entities = model.active_entities
point1 = Geom::Point3d.new(10, 0, 0)
constpoint = entities.add_cpoint(point1)
pages = model.pages
page = pages.add("My Page")
page.set_drawingelement_visibility(constpoint, false)

Parameters:

Returns:

  • (Boolean)

Version:

  • SketchUp 2020.0

#set_visibility(layer, visible_for_page) ⇒ Sketchup::Page #set_visibility(layer_folder, visible_for_page) ⇒ Sketchup::Page

The #set_visibility method sets the visibility for a layer or layer folder on a page.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add("My Page")
layer = model.layers.add("My Layer")
page.set_visibility(layer, false)

Overloads:

Returns:

Version:

  • SketchUp 6.0

#shadow_infoObject

The shadow_info method retrieves the ShadowInfo object for the page.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
shadowinfo = page.shadow_info

Returns:

  • shadowinfo - a ShadowInfo object if successful, nil if the page does not save shadow information

Version:

  • SketchUp 6.0

#styleObject

The style method retrieves the style associated with the page.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
style = page.style

Returns:

  • style - the Style object if successful

Version:

  • SketchUp 6.0

#transition_timeObject

Get the amount of time that it takes to transition to this page during a slideshow or animation export. If this value is -1, it means to use the default transition time.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
time = page.transition_time

Returns:

  • transitiontime - the amount of time it takes to transition to this page during a slideshow or animation export.

Version:

  • SketchUp 6.0

#transition_time=(trans_time) ⇒ Object

The transition_time= method is used to set the transition time.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
time = page.transition_time=20

Returns transitiontime - the new transition time.

Parameters:

  • trans_time

    The transition time in seconds.

Returns:

  • transitiontime - the new transition time

Version:

  • SketchUp 6.0

#update(flags) ⇒ Boolean

The #update method performs an update on the page properties based on the current view that the user has. What properties of the Page get updated are controlled via an integer whose bits corresponds to different properties. These flags can be used individually or combined using bitwise OR.

PAGE_USE_CAMERA            # Camera Location
PAGE_USE_RENDERING_OPTIONS # Drawing Style
PAGE_USE_SHADOWINFO        # Shadow Setting
PAGE_USE_SKETCHCS          # Axes Location
PAGE_USE_HIDDEN            # Hidden Geometry & Objects (Up 2019 and older)
PAGE_USE_HIDDEN_GEOMETRY   # Hidden Geometry (SU 2020 and later)
PAGE_USE_HIDDEN_OBJECTS    # Hidden Objects (SU 2020 and later)
PAGE_USE_LAYER_VISIBILITY  # Visible Layers
PAGE_USE_SECTION_PLANES    # Active Section Planes
PAGE_USE_ALL               # All possible scene properties

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
status = page.update

# Updates Camera Location, Shadow Settings and Visible Layers.
flags = PAGE_USE_CAMERA | PAGE_USE_SHADOWINFO | PAGE_USE_LAYER_VISIBILITY
status = page.update(flags)

Parameters:

  • flags (Integer)

    The bitwise OR of the bit flags.

Returns:

  • (Boolean)

Version:

  • SketchUp 6.0

#use_axes=(pagesettings) ⇒ Object

The use_axes= method sets the page's axes property.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
# Set use_axes to false
status = page.use_axes=false

Returns status - true if you are saving the property, false if you are not saving the property.

Parameters:

  • pagesettings

    true if you want your page to save this property, false if you do not want your page to save this property.

Returns:

  • status - true if you are saving the property, false if you are not saving the property.

Version:

  • SketchUp 6.0

#use_axes?Boolean

The use_axes? method determines whether you are storing the axes property with the page.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
status = page.use_axes?

Returns:

  • (Boolean)

    status - true if you are storing the this property with the page, false if you are not storing this property with the page.

Version:

  • SketchUp 6.0

#use_camera=(setting) ⇒ Object

The use_camera= method sets the page's camera property.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
status = page.use_camera = true

Returns status - true if you are saving the property, false if you are not saving the property.

Parameters:

  • setting

    true if you want your page to save this property, false if you do not want your page to save this property.

Returns:

  • status - true if you are saving the property, false if you are not saving the property.

Version:

  • SketchUp 6.0

#use_camera?Boolean

The use_camera? method determines whether you are storing the camera property with the page.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
status = page.use_camera?

Returns:

  • (Boolean)

    status - true if you are storing the this property with the page, false if you are not storing this property with the page.

Version:

  • SketchUp 6.0

#use_hidden=(setting) ⇒ Object

Deprecated.

The functionality is replaced by #use_hidden_geometry= and #use_hidden_objects= in SketchUp 2020.1.

The use_hidden= method sets the page's hidden property.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
status = page.use_hidden = false

Returns status - true if you are saving the property, false if you are not saving the property.

Parameters:

  • setting

    true if you want your page to save this property, false if you do not want your page to save this property.

Returns:

  • status - true if you are saving the property, false if you are not saving the property.

See Also:

Version:

  • SketchUp 6.0

#use_hidden?Boolean

Deprecated.

The functionality is replaced by #use_hidden_geometry? and #use_hidden_objects? in SketchUp 2020.1.

The use_hidden? method determines whether you are storing the hidden property with the page.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add("My Page")
status = page.use_hidden?

Returns:

  • (Boolean)

    status - true if you are storing the this property with the page, false if you are not storing this property with the page.

See Also:

Version:

  • SketchUp 6.0

#use_hidden_geometry=(setting) ⇒ Object

Sets the page's use hidden geometry property.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add("My Page")
status = page.use_hidden_geometry = false

Parameters:

  • setting (Boolean)

    `true` if you want your page to save this property, `false` if you do not want your page to save this property.

Version:

  • SketchUp 2020.1

#use_hidden_geometry?Boolean

Returns the use hidden geometry property from the page.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add("My Page")
status = page.use_hidden_geometry?

Returns:

  • (Boolean)

Version:

  • SketchUp 2020.1

#use_hidden_layers=(setting) ⇒ Object

The use_hidden_layers= method sets the page's hidden layers property.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
status = page.use_hidden_layers = false

Returns status - true if you are saving the property, false if you are not saving the property.

Parameters:

  • setting

    true if you want your page to save this property, false if you do not want your page to save this property.

Returns:

  • status - true if you are saving the property, false if you are not saving the property.

Version:

  • SketchUp 6.0

#use_hidden_layers?Boolean

The use_hidden_layers? method determines whether you are storing the hidden layers property with the page.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
status = page.use_hidden_layers?

Returns:

  • (Boolean)

    status - true if you are storing the this property with the page, false if you are not storing this property with the page.

Version:

  • SketchUp 6.0

#use_hidden_objects=(setting) ⇒ Object

Sets the page's use hidden objects property.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add("My Page")
status = page.use_hidden_objects = false

Parameters:

  • setting (Boolean)

    `true` if you want your page to save this property, `false` if you do not want your page to save this property.

Version:

  • SketchUp 2020.1

#use_hidden_objects?Boolean

Returns the use hidden objects property from the page.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add("My Page")
status = page.use_hidden_objects?

Returns:

  • (Boolean)

Version:

  • SketchUp 2020.1

#use_rendering_options=(setting) ⇒ Object

The use_rendering_optoins= method sets the page's display settings property.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
status = page.use_rendering_options = false

Returns status - true if you are saving the property, false if you are not saving the property.

Parameters:

  • setting

    true if you want your page to save this property, false if you do not want your page to save this property.

Returns:

  • status - true if you are saving the property, false if you are not saving the property.

Version:

  • SketchUp 6.0

#use_rendering_options?Boolean

The use_rendering_options? method determines whether you are storing the rendering options property with the page.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
status = page.use_rendering_options?

Returns:

  • (Boolean)

    status - true if you are storing the this property with the page, false if you are not storing this property with the page.

Version:

  • SketchUp 6.0

#use_section_planes=(setting) ⇒ Object

The use_section_planes= method sets the page's section planes property.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
status = page.use_section_planes=false

Returns status - true if you are saving the property, false if you are not saving the property.

Parameters:

  • setting

    true if you want your page to save this property, false if you do not want your page to save this property.

Returns:

  • status - true if you are saving the property, false if you are not saving the property.

Version:

  • SketchUp 6.0

#use_section_planes?Boolean

The use_section_planes? method determines whether you are storing the section planes property with the page.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
status = page.use_section_planes?

Returns:

  • (Boolean)

    status - true if you are storing the this property with the page, false if you are not storing this property with the page.

Version:

  • SketchUp 6.0

#use_shadow_info=(setting) ⇒ Object

The use_shadow_info= method sets the page's shadow info property.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
status = page.use_shadow_info=false

Returns status - true if you are saving the property, false if you are not saving the property.

Parameters:

  • setting

    true if you want your page to save this property, false if you do not want your page to save this property.

Returns:

  • status - true if you are saving the property, false if you are not saving the property.

Version:

  • SketchUp 6.0

#use_shadow_info?Boolean

The use_shadow_info? method determines whether you are storing the shadow info property with the page.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
status = page.use_shadow_info?

Returns:

  • (Boolean)

    status - true if you are storing the this property with the page, false if you are not storing this property with the page.

Version:

  • SketchUp 6.0

#use_style=(style) ⇒ Object

The use_style= method sets the style to be used by the page.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
style = model.styles[0]
page.use_style = style

Returns nil.

Parameters:

  • style

    The Style object to use.

Returns:

  • nil

Version:

  • SketchUp 6.0

#use_style?Boolean

The use_style? method determines whether storing a style with the page.

Examples:

model = Sketchup.active_model
pages = model.pages
page = pages.add "My Page"
use_style = page.use_style?

Returns:

  • (Boolean)

    status - true if you are storing the this property with the page, false if you are not storing this property with the page.

Version:

  • SketchUp 6.0